//
//  CocoaUtils.m
//  cocoautils
//
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "CocoaUtils.h"

@implementation CocoaUtils

-(void)doCallbackOnAppKitThread:(NSMutableArray *) args {

    JavaVM *vm = (JavaVM*)  [[args objectAtIndex:0] pointerValue];
    jobject runnable = (jobject) [[args objectAtIndex:1] pointerValue];

    //attach the current thread to java
    JNIEnv *env = NULL;
    (*vm)->AttachCurrentThread(vm, (void **)&env, (void *)  JNI_VERSION_1_2);

    //callback to java
    jclass clazz = (*env)->FindClass(env, "org/mozilla/browser/impl/CocoaUtils");
    if ((*env)->ExceptionOccurred(env)) return;
    jmethodID mid = (*env)->GetStaticMethodID(env, clazz, "callbackOnAppKitThread", "(Lorg/mozilla/browser/RunnableEx;)V");
    if ((*env)->ExceptionOccurred(env)) return;
    (*env)->CallStaticVoidMethod(env, clazz, mid, runnable);

    //if exception occured, pass it to the caller thread
    jthrowable exc = (*env)->ExceptionOccurred(env);
    if (exc) {
        (*env)->ExceptionClear(env);
    }
    NSValue *item2 = [NSValue value:&exc withObjCType:@encode(jobject)];
    [args addObject: item2];

}

@end

JNIEXPORT void JNICALL Java_org_mozilla_browser_impl_CocoaUtils_runOnAppKitThread
  (JNIEnv *env, jclass cls, jobject runnable)
{
    //Cocoa always expects there to be an autorelease pool available.
    //If a pool is not available, autoreleased objects do not get
    //released and you leak memory.
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    //need the VM, so that we can later attach the AppKit thread
    //to obtain valid JNIEnv
    JavaVM *vm;
    (*env)->GetJavaVM(env, &vm);

    CocoaUtils *cu = [[CocoaUtils alloc] init];
    //create params for the selector call
    NSMutableArray *args = [NSMutableArray arrayWithCapacity: 3];
    NSValue
        *item0 = [NSValue value:&vm withObjCType:@encode(JavaVM*)],
        *item1 = [NSValue value:&runnable withObjCType:@encode(jobject)];
    [args addObject: item0];
    [args addObject: item1];
    //synchronously call our selector on the AppKit thread
    [cu performSelectorOnMainThread: @selector(doCallbackOnAppKitThread:)
      withObject: args
      waitUntilDone: YES];

    jobject exc = (jobject) [[args objectAtIndex:2] pointerValue];
    if (exc) (*env)->Throw(env, exc);

    //cleanup
    [cu release];
    [pool release];
}

